/* ProcessManager.c generated by valac 0.43.92, the Vala compiler
 * generated from ProcessManager.vala, do not modify */

/* ProcessManager.vala
 *
 * Copyright 2019 Hannes Schulze
 *
 * Simplified version of ProcessManager.vala by stsdc published under
 * the GPL-3.0 license:
 * https://github.com/stsdc/monitor/blob/master/src/Managers/ProcessManager.vala
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gee.h>
#include <gio/gio.h>
#include <glibtop/cpu.h>
#include <glibtop.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include <glibtop/proclist.h>
#include <gobject/gvaluecollector.h>

#define OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER (optimizer_utils_process_manager_get_type ())
#define OPTIMIZER_UTILS_PROCESS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER, OptimizerUtilsProcessManager))
#define OPTIMIZER_UTILS_PROCESS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER, OptimizerUtilsProcessManagerClass))
#define OPTIMIZER_UTILS_IS_PROCESS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER))
#define OPTIMIZER_UTILS_IS_PROCESS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER))
#define OPTIMIZER_UTILS_PROCESS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER, OptimizerUtilsProcessManagerClass))

typedef struct _OptimizerUtilsProcessManager OptimizerUtilsProcessManager;
typedef struct _OptimizerUtilsProcessManagerClass OptimizerUtilsProcessManagerClass;
typedef struct _OptimizerUtilsProcessManagerPrivate OptimizerUtilsProcessManagerPrivate;

#define OPTIMIZER_UTILS_TYPE_PROCESS (optimizer_utils_process_get_type ())
#define OPTIMIZER_UTILS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), OPTIMIZER_UTILS_TYPE_PROCESS, OptimizerUtilsProcess))
#define OPTIMIZER_UTILS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), OPTIMIZER_UTILS_TYPE_PROCESS, OptimizerUtilsProcessClass))
#define OPTIMIZER_UTILS_IS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), OPTIMIZER_UTILS_TYPE_PROCESS))
#define OPTIMIZER_UTILS_IS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), OPTIMIZER_UTILS_TYPE_PROCESS))
#define OPTIMIZER_UTILS_PROCESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), OPTIMIZER_UTILS_TYPE_PROCESS, OptimizerUtilsProcessClass))

typedef struct _OptimizerUtilsProcess OptimizerUtilsProcess;
typedef struct _OptimizerUtilsProcessClass OptimizerUtilsProcessClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _optimizer_utils_process_manager_unref0(var) ((var == NULL) ? NULL : (var = (optimizer_utils_process_manager_unref (var), NULL)))
#define _optimizer_utils_process_unref0(var) ((var == NULL) ? NULL : (var = (optimizer_utils_process_unref (var), NULL)))
typedef struct _OptimizerUtilsProcessManagerUpdateProcessesData OptimizerUtilsProcessManagerUpdateProcessesData;
typedef struct _Block2Data Block2Data;
typedef struct _OptimizerUtilsParamSpecProcessManager OptimizerUtilsParamSpecProcessManager;
enum  {
	OPTIMIZER_UTILS_PROCESS_MANAGER_PROCESS_ADDED_SIGNAL,
	OPTIMIZER_UTILS_PROCESS_MANAGER_PROCESS_REMOVED_SIGNAL,
	OPTIMIZER_UTILS_PROCESS_MANAGER_UPDATED_SIGNAL,
	OPTIMIZER_UTILS_PROCESS_MANAGER_NUM_SIGNALS
};
static guint optimizer_utils_process_manager_signals[OPTIMIZER_UTILS_PROCESS_MANAGER_NUM_SIGNALS] = {0};

struct _OptimizerUtilsProcessManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	OptimizerUtilsProcessManagerPrivate * priv;
};

struct _OptimizerUtilsProcessManagerClass {
	GTypeClass parent_class;
	void (*finalize) (OptimizerUtilsProcessManager *self);
};

struct _OptimizerUtilsProcessManagerPrivate {
	gdouble _cpu_load;
	gdouble* _cpu_loads;
	gint _cpu_loads_length1;
	gint __cpu_loads_size_;
	guint64 cpu_last_used;
	guint64 cpu_last_total;
	guint64* cpu_last_useds;
	gint cpu_last_useds_length1;
	gint _cpu_last_useds_size_;
	guint64* cpu_last_totals;
	gint cpu_last_totals_length1;
	gint _cpu_last_totals_size_;
	GeeHashMap* process_list;
	GeeHashSet* kernel_process_blacklist;
};

struct _OptimizerUtilsProcessManagerUpdateProcessesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	OptimizerUtilsProcessManager* self;
	glibtop_cpu cpu_data;
	glibtop_cpu _tmp0_;
	guint64 used;
	glibtop_cpu _tmp1_;
	glibtop_cpu _tmp2_;
	glibtop_cpu _tmp3_;
	glibtop_cpu _tmp4_;
	glibtop_cpu _tmp5_;
	guint64* _tmp6_;
	gint _tmp6__length1;
	gdouble* _tmp7_;
	gdouble* _tmp8_;
	gint _tmp8__length1;
	guint64* useds;
	glibtop_cpu _tmp9_;
	guint64* _tmp10_;
	gint _tmp10__length1;
	guint64* _tmp11_;
	gint useds_length1;
	gint _useds_size_;
	gint i;
	gboolean _tmp12_;
	gint _tmp13_;
	glibtop_cpu _tmp14_;
	guint64* _tmp15_;
	gint _tmp15__length1;
	guint64* _tmp16_;
	gint _tmp16__length1;
	glibtop_cpu _tmp17_;
	guint64* _tmp18_;
	gint _tmp18__length1;
	guint64 _tmp19_;
	glibtop_cpu _tmp20_;
	guint64* _tmp21_;
	gint _tmp21__length1;
	guint64 _tmp22_;
	glibtop_cpu _tmp23_;
	guint64* _tmp24_;
	gint _tmp24__length1;
	guint64 _tmp25_;
	gint _vala1_i;
	gboolean _tmp26_;
	gint _tmp27_;
	glibtop_cpu _tmp28_;
	guint64* _tmp29_;
	gint _tmp29__length1;
	gdouble* _tmp30_;
	gint _tmp30__length1;
	gdouble* _tmp31_;
	gint _tmp31__length1;
	guint64* _tmp32_;
	gint _tmp32__length1;
	guint64 _tmp33_;
	guint64* _tmp34_;
	gint _tmp34__length1;
	guint64 _tmp35_;
	glibtop_cpu _tmp36_;
	guint64* _tmp37_;
	gint _tmp37__length1;
	guint64 _tmp38_;
	guint64* _tmp39_;
	gint _tmp39__length1;
	guint64 _tmp40_;
	GeeHashSet* remove_me;
	GeeHashSet* _tmp41_;
	GeeIterator* _process_it;
	GeeHashMap* _tmp42_;
	GeeCollection* _tmp43_;
	GeeCollection* _tmp44_;
	GeeCollection* _tmp45_;
	GeeIterator* _tmp46_;
	GeeIterator* _tmp47_;
	GeeIterator* _tmp48_;
	OptimizerUtilsProcess* process;
	GeeIterator* _tmp49_;
	gpointer _tmp50_;
	OptimizerUtilsProcess* _tmp51_;
	glibtop_cpu _tmp52_;
	GeeHashSet* _tmp53_;
	OptimizerUtilsProcess* _tmp54_;
	gint _tmp55_;
	gint _tmp56_;
	GeeIterator* _pid_it;
	GeeHashSet* _tmp57_;
	GeeIterator* _tmp58_;
	GeeIterator* _tmp59_;
	gint pid;
	GeeIterator* _tmp60_;
	gpointer _tmp61_;
	uid_t uid;
	glibtop_proclist proclist;
	gint* pids;
	glibtop_proclist _tmp62_;
	gint* _tmp63_;
	gint pids_length1;
	gint _pids_size_;
	gint _vala2_i;
	gboolean _tmp64_;
	gint _tmp65_;
	glibtop_proclist _tmp66_;
	gint _vala1_pid;
	gint* _tmp67_;
	gint _tmp67__length1;
	gint _tmp68_;
	gboolean _tmp69_;
	GeeHashMap* _tmp70_;
	GeeHashSet* _tmp71_;
	OptimizerUtilsProcess* _tmp72_;
	OptimizerUtilsProcess* _tmp73_;
	glibtop_cpu _tmp74_;
	guint64* _tmp75_;
	gint _tmp75__length1;
	guint64* _tmp76_;
	gint _tmp76__length1;
	glibtop_cpu _tmp77_;
	guint64* _tmp78_;
	gint _tmp78__length1;
	guint64* _tmp79_;
	gint _tmp79__length1;
};

struct _Block2Data {
	int _ref_count_;
	OptimizerUtilsProcessManager* self;
	OptimizerUtilsProcess* process;
};

struct _OptimizerUtilsParamSpecProcessManager {
	GParamSpec parent_instance;
};

static gint OptimizerUtilsProcessManager_private_offset;
static gpointer optimizer_utils_process_manager_parent_class = NULL;
static OptimizerUtilsProcessManager* optimizer_utils_process_manager_instance;
static OptimizerUtilsProcessManager* optimizer_utils_process_manager_instance = NULL;

gpointer optimizer_utils_process_manager_ref (gpointer instance);
void optimizer_utils_process_manager_unref (gpointer instance);
GParamSpec* optimizer_utils_param_spec_process_manager (const gchar* name,
                                                        const gchar* nick,
                                                        const gchar* blurb,
                                                        GType object_type,
                                                        GParamFlags flags);
void optimizer_utils_value_set_process_manager (GValue* value,
                                                gpointer v_object);
void optimizer_utils_value_take_process_manager (GValue* value,
                                                 gpointer v_object);
gpointer optimizer_utils_value_get_process_manager (const GValue* value);
GType optimizer_utils_process_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OptimizerUtilsProcessManager, optimizer_utils_process_manager_unref)
gpointer optimizer_utils_process_ref (gpointer instance);
void optimizer_utils_process_unref (gpointer instance);
GParamSpec* optimizer_utils_param_spec_process (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
void optimizer_utils_value_set_process (GValue* value,
                                        gpointer v_object);
void optimizer_utils_value_take_process (GValue* value,
                                         gpointer v_object);
gpointer optimizer_utils_value_get_process (const GValue* value);
GType optimizer_utils_process_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OptimizerUtilsProcess, optimizer_utils_process_unref)
static OptimizerUtilsProcessManager* optimizer_utils_process_manager_new (void);
static OptimizerUtilsProcessManager* optimizer_utils_process_manager_construct (GType object_type);
static void optimizer_utils_process_manager_update_processes (OptimizerUtilsProcessManager* self,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_);
static void optimizer_utils_process_manager_update_processes_finish (OptimizerUtilsProcessManager* self,
                                                              GAsyncResult* _res_);
static gboolean optimizer_utils_process_manager_handle_timeout (OptimizerUtilsProcessManager* self);
static gboolean _optimizer_utils_process_manager_handle_timeout_gsource_func (gpointer self);
OptimizerUtilsProcess* optimizer_utils_process_manager_get_process (OptimizerUtilsProcessManager* self,
                                                                    gint pid);
static OptimizerUtilsProcess* optimizer_utils_process_manager_add_process (OptimizerUtilsProcessManager* self,
                                                                    gint pid);
GeeMap* optimizer_utils_process_manager_get_process_list (OptimizerUtilsProcessManager* self);
static void optimizer_utils_process_manager_update_processes_data_free (gpointer _data);
static gboolean optimizer_utils_process_manager_update_processes_co (OptimizerUtilsProcessManagerUpdateProcessesData* _data_);
static void optimizer_utils_process_manager_set_cpu_load (OptimizerUtilsProcessManager* self,
                                                   gdouble value);
static void optimizer_utils_process_manager_set_cpu_loads (OptimizerUtilsProcessManager* self,
                                                    gdouble* value,
                                                    gint value_length1);
gdouble* optimizer_utils_process_manager_get_cpu_loads (OptimizerUtilsProcessManager* self,
                                                        gint* result_length1);
gboolean optimizer_utils_process_update (OptimizerUtilsProcess* self,
                                         guint64 cpu_total,
                                         guint64 cpu_last_total);
gint optimizer_utils_process_get_pid (OptimizerUtilsProcess* self);
static void optimizer_utils_process_manager_remove_process (OptimizerUtilsProcessManager* self,
                                                     gint pid);
static guint64* _vala_array_dup3 (guint64* self,
                           int length);
static guint64* _vala_array_dup4 (guint64* self,
                           int length);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
OptimizerUtilsProcess* optimizer_utils_process_new (gint _pid);
OptimizerUtilsProcess* optimizer_utils_process_construct (GType object_type,
                                                          gint _pid);
gboolean optimizer_utils_process_get_exists (OptimizerUtilsProcess* self);
gint optimizer_utils_process_get_pgrp (OptimizerUtilsProcess* self);
static gboolean ____lambda17_ (Block2Data* _data2_);
static gboolean _____lambda17__gsource_func (gpointer self);
OptimizerUtilsProcessManager* optimizer_utils_process_manager_get_instance (void);
gdouble optimizer_utils_process_manager_get_cpu_load (OptimizerUtilsProcessManager* self);
static gdouble* _vala_array_dup5 (gdouble* self,
                           int length);
static void g_cclosure_user_marshal_VOID__OPTIMIZER_UTILS_PROCESS (GClosure * closure,
                                                            GValue * return_value,
                                                            guint n_param_values,
                                                            const GValue * param_values,
                                                            gpointer invocation_hint,
                                                            gpointer marshal_data);
static void optimizer_utils_process_manager_finalize (OptimizerUtilsProcessManager * obj);
static gint _vala_array_length (gpointer array);

static inline gpointer
optimizer_utils_process_manager_get_instance_private (OptimizerUtilsProcessManager* self)
{
	return G_STRUCT_MEMBER_P (self, OptimizerUtilsProcessManager_private_offset);
}

/**
         * Constructs a new {@code ProcessManager} object
         */
static gboolean
_optimizer_utils_process_manager_handle_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = optimizer_utils_process_manager_handle_timeout ((OptimizerUtilsProcessManager*) self);
#line 61 "../src/utils/ProcessManager.vala"
	return result;
#line 344 "ProcessManager.c"
}

static OptimizerUtilsProcessManager*
optimizer_utils_process_manager_construct (GType object_type)
{
	OptimizerUtilsProcessManager* self = NULL;
	GeeHashMap* _tmp0_;
	GeeHashSet* _tmp1_;
#line 55 "../src/utils/ProcessManager.vala"
	self = (OptimizerUtilsProcessManager*) g_type_create_instance (object_type);
#line 56 "../src/utils/ProcessManager.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, OPTIMIZER_UTILS_TYPE_PROCESS, (GBoxedCopyFunc) optimizer_utils_process_ref, (GDestroyNotify) optimizer_utils_process_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 56 "../src/utils/ProcessManager.vala"
	_g_object_unref0 (self->priv->process_list);
#line 56 "../src/utils/ProcessManager.vala"
	self->priv->process_list = _tmp0_;
#line 57 "../src/utils/ProcessManager.vala"
	_tmp1_ = gee_hash_set_new (G_TYPE_INT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 57 "../src/utils/ProcessManager.vala"
	_g_object_unref0 (self->priv->kernel_process_blacklist);
#line 57 "../src/utils/ProcessManager.vala"
	self->priv->kernel_process_blacklist = _tmp1_;
#line 58 "../src/utils/ProcessManager.vala"
	optimizer_utils_process_manager_update_processes (self, NULL, NULL);
#line 61 "../src/utils/ProcessManager.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 2000, _optimizer_utils_process_manager_handle_timeout_gsource_func, optimizer_utils_process_manager_ref (self), optimizer_utils_process_manager_unref);
#line 55 "../src/utils/ProcessManager.vala"
	return self;
#line 373 "ProcessManager.c"
}

static OptimizerUtilsProcessManager*
optimizer_utils_process_manager_new (void)
{
#line 55 "../src/utils/ProcessManager.vala"
	return optimizer_utils_process_manager_construct (OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER);
#line 381 "ProcessManager.c"
}

/**
         * Gets a process by its pid, making sure that it's updated.
         */
OptimizerUtilsProcess*
optimizer_utils_process_manager_get_process (OptimizerUtilsProcessManager* self,
                                             gint pid)
{
	OptimizerUtilsProcess* result = NULL;
	GeeHashSet* _tmp0_;
	GeeHashMap* _tmp1_;
	OptimizerUtilsProcess* _tmp4_;
#line 67 "../src/utils/ProcessManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 69 "../src/utils/ProcessManager.vala"
	_tmp0_ = self->priv->kernel_process_blacklist;
#line 69 "../src/utils/ProcessManager.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (gpointer) ((gintptr) pid))) {
#line 70 "../src/utils/ProcessManager.vala"
		result = NULL;
#line 70 "../src/utils/ProcessManager.vala"
		return result;
#line 405 "ProcessManager.c"
	}
#line 74 "../src/utils/ProcessManager.vala"
	_tmp1_ = self->priv->process_list;
#line 74 "../src/utils/ProcessManager.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, (gpointer) ((gintptr) pid))) {
#line 411 "ProcessManager.c"
		GeeHashMap* _tmp2_;
		gpointer _tmp3_;
#line 75 "../src/utils/ProcessManager.vala"
		_tmp2_ = self->priv->process_list;
#line 75 "../src/utils/ProcessManager.vala"
		_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) pid));
#line 75 "../src/utils/ProcessManager.vala"
		result = (OptimizerUtilsProcess*) _tmp3_;
#line 75 "../src/utils/ProcessManager.vala"
		return result;
#line 422 "ProcessManager.c"
	}
#line 82 "../src/utils/ProcessManager.vala"
	_tmp4_ = optimizer_utils_process_manager_add_process (self, pid);
#line 82 "../src/utils/ProcessManager.vala"
	result = _tmp4_;
#line 82 "../src/utils/ProcessManager.vala"
	return result;
#line 430 "ProcessManager.c"
}

/**
         * Gets a read only map of the processes currently cached
         */
GeeMap*
optimizer_utils_process_manager_get_process_list (OptimizerUtilsProcessManager* self)
{
	GeeMap* result = NULL;
	GeeHashMap* _tmp0_;
	GeeMap* _tmp1_;
	GeeMap* _tmp2_;
#line 88 "../src/utils/ProcessManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 89 "../src/utils/ProcessManager.vala"
	_tmp0_ = self->priv->process_list;
#line 89 "../src/utils/ProcessManager.vala"
	_tmp1_ = gee_abstract_map_get_read_only_view ((GeeAbstractMap*) _tmp0_);
#line 89 "../src/utils/ProcessManager.vala"
	_tmp2_ = _tmp1_;
#line 89 "../src/utils/ProcessManager.vala"
	result = _tmp2_;
#line 89 "../src/utils/ProcessManager.vala"
	return result;
#line 455 "ProcessManager.c"
}

/**
         * Handle updating the process list
         */
static gboolean
optimizer_utils_process_manager_handle_timeout (OptimizerUtilsProcessManager* self)
{
	gboolean result = FALSE;
#line 95 "../src/utils/ProcessManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 96 "../src/utils/ProcessManager.vala"
	optimizer_utils_process_manager_update_processes (self, NULL, NULL);
#line 97 "../src/utils/ProcessManager.vala"
	result = TRUE;
#line 97 "../src/utils/ProcessManager.vala"
	return result;
#line 473 "ProcessManager.c"
}

static void
optimizer_utils_process_manager_update_processes_data_free (gpointer _data)
{
	OptimizerUtilsProcessManagerUpdateProcessesData* _data_;
	_data_ = _data;
#line 31 "../src/utils/ProcessManager.vala"
	_optimizer_utils_process_manager_unref0 (_data_->self);
#line 31 "../src/utils/ProcessManager.vala"
	g_slice_free (OptimizerUtilsProcessManagerUpdateProcessesData, _data_);
#line 485 "ProcessManager.c"
}

static gpointer
_optimizer_utils_process_manager_ref0 (gpointer self)
{
#line 31 "../src/utils/ProcessManager.vala"
	return self ? optimizer_utils_process_manager_ref (self) : NULL;
#line 493 "ProcessManager.c"
}

static void
optimizer_utils_process_manager_update_processes (OptimizerUtilsProcessManager* self,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	OptimizerUtilsProcessManagerUpdateProcessesData* _data_;
	OptimizerUtilsProcessManager* _tmp0_;
#line 31 "../src/utils/ProcessManager.vala"
	_data_ = g_slice_new0 (OptimizerUtilsProcessManagerUpdateProcessesData);
#line 31 "../src/utils/ProcessManager.vala"
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
#line 31 "../src/utils/ProcessManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, optimizer_utils_process_manager_update_processes_data_free);
#line 31 "../src/utils/ProcessManager.vala"
	_tmp0_ = _optimizer_utils_process_manager_ref0 (self);
#line 31 "../src/utils/ProcessManager.vala"
	_data_->self = _tmp0_;
#line 31 "../src/utils/ProcessManager.vala"
	optimizer_utils_process_manager_update_processes_co (_data_);
#line 515 "ProcessManager.c"
}

static void
optimizer_utils_process_manager_update_processes_finish (OptimizerUtilsProcessManager* self,
                                                         GAsyncResult* _res_)
{
	OptimizerUtilsProcessManagerUpdateProcessesData* _data_;
#line 31 "../src/utils/ProcessManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 525 "ProcessManager.c"
}

/**
         * Gets all new process and adds them
         */
static guint64*
_vala_array_dup3 (guint64* self,
                  int length)
{
#line 150 "../src/utils/ProcessManager.vala"
	return g_memdup (self, length * sizeof (guint64));
#line 537 "ProcessManager.c"
}

static guint64*
_vala_array_dup4 (guint64* self,
                  int length)
{
#line 151 "../src/utils/ProcessManager.vala"
	return g_memdup (self, length * sizeof (guint64));
#line 546 "ProcessManager.c"
}

static gboolean
optimizer_utils_process_manager_update_processes_co (OptimizerUtilsProcessManagerUpdateProcessesData* _data_)
{
#line 103 "../src/utils/ProcessManager.vala"
	switch (_data_->_state_) {
#line 103 "../src/utils/ProcessManager.vala"
		case 0:
#line 556 "ProcessManager.c"
		goto _state_0;
		default:
#line 103 "../src/utils/ProcessManager.vala"
		g_assert_not_reached ();
#line 561 "ProcessManager.c"
	}
	_state_0:
#line 106 "../src/utils/ProcessManager.vala"
	memset (&_data_->_tmp0_, 0, sizeof (glibtop_cpu));
#line 106 "../src/utils/ProcessManager.vala"
	glibtop_get_cpu (&_data_->_tmp0_);
#line 106 "../src/utils/ProcessManager.vala"
	_data_->cpu_data = _data_->_tmp0_;
#line 107 "../src/utils/ProcessManager.vala"
	_data_->_tmp1_ = _data_->cpu_data;
#line 107 "../src/utils/ProcessManager.vala"
	_data_->_tmp2_ = _data_->cpu_data;
#line 107 "../src/utils/ProcessManager.vala"
	_data_->_tmp3_ = _data_->cpu_data;
#line 107 "../src/utils/ProcessManager.vala"
	_data_->used = (_data_->_tmp1_.user + _data_->_tmp2_.nice) + _data_->_tmp3_.sys;
#line 108 "../src/utils/ProcessManager.vala"
	_data_->_tmp4_ = _data_->cpu_data;
#line 108 "../src/utils/ProcessManager.vala"
	optimizer_utils_process_manager_set_cpu_load (_data_->self, ((gdouble) (_data_->used - _data_->self->priv->cpu_last_used)) / (_data_->_tmp4_.total - _data_->self->priv->cpu_last_total));
#line 109 "../src/utils/ProcessManager.vala"
	_data_->_tmp5_ = _data_->cpu_data;
#line 109 "../src/utils/ProcessManager.vala"
	_data_->_tmp6_ = _data_->_tmp5_.xcpu_user;
#line 109 "../src/utils/ProcessManager.vala"
	_data_->_tmp6__length1 = _vala_array_length (_data_->_tmp5_.xcpu_user);
#line 109 "../src/utils/ProcessManager.vala"
	_data_->_tmp7_ = g_new0 (gdouble, _data_->_tmp6__length1);
#line 109 "../src/utils/ProcessManager.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 109 "../src/utils/ProcessManager.vala"
	_data_->_tmp8__length1 = _data_->_tmp6__length1;
#line 109 "../src/utils/ProcessManager.vala"
	optimizer_utils_process_manager_set_cpu_loads (_data_->self, _data_->_tmp8_, _data_->_tmp6__length1);
#line 109 "../src/utils/ProcessManager.vala"
	_data_->_tmp8_ = (g_free (_data_->_tmp8_), NULL);
#line 110 "../src/utils/ProcessManager.vala"
	_data_->_tmp9_ = _data_->cpu_data;
#line 110 "../src/utils/ProcessManager.vala"
	_data_->_tmp10_ = _data_->_tmp9_.xcpu_user;
#line 110 "../src/utils/ProcessManager.vala"
	_data_->_tmp10__length1 = _vala_array_length (_data_->_tmp9_.xcpu_user);
#line 110 "../src/utils/ProcessManager.vala"
	_data_->_tmp11_ = g_new0 (guint64, _data_->_tmp10__length1);
#line 110 "../src/utils/ProcessManager.vala"
	_data_->useds = _data_->_tmp11_;
#line 110 "../src/utils/ProcessManager.vala"
	_data_->useds_length1 = _data_->_tmp10__length1;
#line 110 "../src/utils/ProcessManager.vala"
	_data_->_useds_size_ = _data_->useds_length1;
#line 612 "ProcessManager.c"
	{
#line 112 "../src/utils/ProcessManager.vala"
		_data_->i = 0;
#line 616 "ProcessManager.c"
		{
#line 112 "../src/utils/ProcessManager.vala"
			_data_->_tmp12_ = TRUE;
#line 112 "../src/utils/ProcessManager.vala"
			while (TRUE) {
#line 112 "../src/utils/ProcessManager.vala"
				if (!_data_->_tmp12_) {
#line 112 "../src/utils/ProcessManager.vala"
					_data_->_tmp13_ = _data_->i;
#line 112 "../src/utils/ProcessManager.vala"
					_data_->i = _data_->_tmp13_ + 1;
#line 628 "ProcessManager.c"
				}
#line 112 "../src/utils/ProcessManager.vala"
				_data_->_tmp12_ = FALSE;
#line 112 "../src/utils/ProcessManager.vala"
				_data_->_tmp14_ = _data_->cpu_data;
#line 112 "../src/utils/ProcessManager.vala"
				_data_->_tmp15_ = _data_->_tmp14_.xcpu_user;
#line 112 "../src/utils/ProcessManager.vala"
				_data_->_tmp15__length1 = _vala_array_length (_data_->_tmp14_.xcpu_user);
#line 112 "../src/utils/ProcessManager.vala"
				if (!(_data_->i < _data_->_tmp15__length1)) {
#line 112 "../src/utils/ProcessManager.vala"
					break;
#line 642 "ProcessManager.c"
				}
#line 113 "../src/utils/ProcessManager.vala"
				_data_->_tmp16_ = _data_->useds;
#line 113 "../src/utils/ProcessManager.vala"
				_data_->_tmp16__length1 = _data_->useds_length1;
#line 113 "../src/utils/ProcessManager.vala"
				_data_->_tmp17_ = _data_->cpu_data;
#line 113 "../src/utils/ProcessManager.vala"
				_data_->_tmp18_ = _data_->_tmp17_.xcpu_user;
#line 113 "../src/utils/ProcessManager.vala"
				_data_->_tmp18__length1 = _vala_array_length (_data_->_tmp17_.xcpu_user);
#line 113 "../src/utils/ProcessManager.vala"
				_data_->_tmp19_ = _data_->_tmp18_[_data_->i];
#line 113 "../src/utils/ProcessManager.vala"
				_data_->_tmp20_ = _data_->cpu_data;
#line 113 "../src/utils/ProcessManager.vala"
				_data_->_tmp21_ = _data_->_tmp20_.xcpu_nice;
#line 113 "../src/utils/ProcessManager.vala"
				_data_->_tmp21__length1 = _vala_array_length (_data_->_tmp20_.xcpu_nice);
#line 113 "../src/utils/ProcessManager.vala"
				_data_->_tmp22_ = _data_->_tmp21_[_data_->i];
#line 113 "../src/utils/ProcessManager.vala"
				_data_->_tmp23_ = _data_->cpu_data;
#line 113 "../src/utils/ProcessManager.vala"
				_data_->_tmp24_ = _data_->_tmp23_.xcpu_sys;
#line 113 "../src/utils/ProcessManager.vala"
				_data_->_tmp24__length1 = _vala_array_length (_data_->_tmp23_.xcpu_sys);
#line 113 "../src/utils/ProcessManager.vala"
				_data_->_tmp25_ = _data_->_tmp24_[_data_->i];
#line 113 "../src/utils/ProcessManager.vala"
				_data_->_tmp16_[_data_->i] = (_data_->_tmp19_ + _data_->_tmp22_) + _data_->_tmp25_;
#line 674 "ProcessManager.c"
			}
		}
	}
	{
#line 116 "../src/utils/ProcessManager.vala"
		_data_->_vala1_i = 0;
#line 681 "ProcessManager.c"
		{
#line 116 "../src/utils/ProcessManager.vala"
			_data_->_tmp26_ = TRUE;
#line 116 "../src/utils/ProcessManager.vala"
			while (TRUE) {
#line 116 "../src/utils/ProcessManager.vala"
				if (!_data_->_tmp26_) {
#line 116 "../src/utils/ProcessManager.vala"
					_data_->_tmp27_ = _data_->_vala1_i;
#line 116 "../src/utils/ProcessManager.vala"
					_data_->_vala1_i = _data_->_tmp27_ + 1;
#line 693 "ProcessManager.c"
				}
#line 116 "../src/utils/ProcessManager.vala"
				_data_->_tmp26_ = FALSE;
#line 116 "../src/utils/ProcessManager.vala"
				_data_->_tmp28_ = _data_->cpu_data;
#line 116 "../src/utils/ProcessManager.vala"
				_data_->_tmp29_ = _data_->_tmp28_.xcpu_user;
#line 116 "../src/utils/ProcessManager.vala"
				_data_->_tmp29__length1 = _vala_array_length (_data_->_tmp28_.xcpu_user);
#line 116 "../src/utils/ProcessManager.vala"
				if (!(_data_->_vala1_i < _data_->_tmp29__length1)) {
#line 116 "../src/utils/ProcessManager.vala"
					break;
#line 707 "ProcessManager.c"
				}
#line 117 "../src/utils/ProcessManager.vala"
				_data_->_tmp30_ = optimizer_utils_process_manager_get_cpu_loads (_data_->self, &_data_->_tmp30__length1);
#line 117 "../src/utils/ProcessManager.vala"
				_data_->_tmp31_ = _data_->_tmp30_;
#line 117 "../src/utils/ProcessManager.vala"
				_data_->_tmp31__length1 = _data_->_tmp30__length1;
#line 117 "../src/utils/ProcessManager.vala"
				_data_->_tmp32_ = _data_->useds;
#line 117 "../src/utils/ProcessManager.vala"
				_data_->_tmp32__length1 = _data_->useds_length1;
#line 117 "../src/utils/ProcessManager.vala"
				_data_->_tmp33_ = _data_->_tmp32_[_data_->_vala1_i];
#line 117 "../src/utils/ProcessManager.vala"
				_data_->_tmp34_ = _data_->self->priv->cpu_last_useds;
#line 117 "../src/utils/ProcessManager.vala"
				_data_->_tmp34__length1 = _data_->self->priv->cpu_last_useds_length1;
#line 117 "../src/utils/ProcessManager.vala"
				_data_->_tmp35_ = _data_->_tmp34_[_data_->_vala1_i];
#line 117 "../src/utils/ProcessManager.vala"
				_data_->_tmp36_ = _data_->cpu_data;
#line 117 "../src/utils/ProcessManager.vala"
				_data_->_tmp37_ = _data_->_tmp36_.xcpu_total;
#line 117 "../src/utils/ProcessManager.vala"
				_data_->_tmp37__length1 = _vala_array_length (_data_->_tmp36_.xcpu_total);
#line 117 "../src/utils/ProcessManager.vala"
				_data_->_tmp38_ = _data_->_tmp37_[_data_->_vala1_i];
#line 117 "../src/utils/ProcessManager.vala"
				_data_->_tmp39_ = _data_->self->priv->cpu_last_totals;
#line 117 "../src/utils/ProcessManager.vala"
				_data_->_tmp39__length1 = _data_->self->priv->cpu_last_totals_length1;
#line 117 "../src/utils/ProcessManager.vala"
				_data_->_tmp40_ = _data_->_tmp39_[_data_->_vala1_i];
#line 117 "../src/utils/ProcessManager.vala"
				_data_->_tmp31_[_data_->_vala1_i] = ((gdouble) (_data_->_tmp33_ - _data_->_tmp35_)) / (_data_->_tmp38_ - _data_->_tmp40_);
#line 743 "ProcessManager.c"
			}
		}
	}
#line 121 "../src/utils/ProcessManager.vala"
	_data_->_tmp41_ = gee_hash_set_new (G_TYPE_INT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 121 "../src/utils/ProcessManager.vala"
	_data_->remove_me = _data_->_tmp41_;
#line 751 "ProcessManager.c"
	{
#line 124 "../src/utils/ProcessManager.vala"
		_data_->_tmp42_ = _data_->self->priv->process_list;
#line 124 "../src/utils/ProcessManager.vala"
		_data_->_tmp43_ = gee_abstract_map_get_values ((GeeAbstractMap*) _data_->_tmp42_);
#line 124 "../src/utils/ProcessManager.vala"
		_data_->_tmp44_ = _data_->_tmp43_;
#line 124 "../src/utils/ProcessManager.vala"
		_data_->_tmp45_ = _data_->_tmp44_;
#line 124 "../src/utils/ProcessManager.vala"
		_data_->_tmp46_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp45_);
#line 124 "../src/utils/ProcessManager.vala"
		_data_->_tmp47_ = _data_->_tmp46_;
#line 124 "../src/utils/ProcessManager.vala"
		_g_object_unref0 (_data_->_tmp45_);
#line 124 "../src/utils/ProcessManager.vala"
		_data_->_process_it = _data_->_tmp47_;
#line 124 "../src/utils/ProcessManager.vala"
		while (TRUE) {
#line 124 "../src/utils/ProcessManager.vala"
			_data_->_tmp48_ = _data_->_process_it;
#line 124 "../src/utils/ProcessManager.vala"
			if (!gee_iterator_next (_data_->_tmp48_)) {
#line 124 "../src/utils/ProcessManager.vala"
				break;
#line 777 "ProcessManager.c"
			}
#line 124 "../src/utils/ProcessManager.vala"
			_data_->_tmp49_ = _data_->_process_it;
#line 124 "../src/utils/ProcessManager.vala"
			_data_->_tmp50_ = gee_iterator_get (_data_->_tmp49_);
#line 124 "../src/utils/ProcessManager.vala"
			_data_->process = (OptimizerUtilsProcess*) _data_->_tmp50_;
#line 125 "../src/utils/ProcessManager.vala"
			_data_->_tmp51_ = _data_->process;
#line 125 "../src/utils/ProcessManager.vala"
			_data_->_tmp52_ = _data_->cpu_data;
#line 125 "../src/utils/ProcessManager.vala"
			if (!optimizer_utils_process_update (_data_->_tmp51_, _data_->_tmp52_.total, _data_->self->priv->cpu_last_total)) {
#line 127 "../src/utils/ProcessManager.vala"
				_data_->_tmp53_ = _data_->remove_me;
#line 127 "../src/utils/ProcessManager.vala"
				_data_->_tmp54_ = _data_->process;
#line 127 "../src/utils/ProcessManager.vala"
				_data_->_tmp55_ = optimizer_utils_process_get_pid (_data_->_tmp54_);
#line 127 "../src/utils/ProcessManager.vala"
				_data_->_tmp56_ = _data_->_tmp55_;
#line 127 "../src/utils/ProcessManager.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp53_, (gpointer) ((gintptr) _data_->_tmp56_));
#line 801 "ProcessManager.c"
			}
#line 124 "../src/utils/ProcessManager.vala"
			_optimizer_utils_process_unref0 (_data_->process);
#line 805 "ProcessManager.c"
		}
#line 124 "../src/utils/ProcessManager.vala"
		_g_object_unref0 (_data_->_process_it);
#line 809 "ProcessManager.c"
	}
	{
#line 132 "../src/utils/ProcessManager.vala"
		_data_->_tmp57_ = _data_->remove_me;
#line 132 "../src/utils/ProcessManager.vala"
		_data_->_tmp58_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _data_->_tmp57_);
#line 132 "../src/utils/ProcessManager.vala"
		_data_->_pid_it = _data_->_tmp58_;
#line 132 "../src/utils/ProcessManager.vala"
		while (TRUE) {
#line 132 "../src/utils/ProcessManager.vala"
			_data_->_tmp59_ = _data_->_pid_it;
#line 132 "../src/utils/ProcessManager.vala"
			if (!gee_iterator_next (_data_->_tmp59_)) {
#line 132 "../src/utils/ProcessManager.vala"
				break;
#line 826 "ProcessManager.c"
			}
#line 132 "../src/utils/ProcessManager.vala"
			_data_->_tmp60_ = _data_->_pid_it;
#line 132 "../src/utils/ProcessManager.vala"
			_data_->_tmp61_ = gee_iterator_get (_data_->_tmp60_);
#line 132 "../src/utils/ProcessManager.vala"
			_data_->pid = (gint) ((gintptr) _data_->_tmp61_);
#line 133 "../src/utils/ProcessManager.vala"
			optimizer_utils_process_manager_remove_process (_data_->self, _data_->pid);
#line 836 "ProcessManager.c"
		}
#line 132 "../src/utils/ProcessManager.vala"
		_g_object_unref0 (_data_->_pid_it);
#line 840 "ProcessManager.c"
	}
#line 136 "../src/utils/ProcessManager.vala"
	_data_->uid = getuid ();
#line 138 "../src/utils/ProcessManager.vala"
	memset (&_data_->_tmp62_, 0, sizeof (glibtop_proclist));
#line 138 "../src/utils/ProcessManager.vala"
	_data_->_tmp63_ = glibtop_get_proclist (&_data_->_tmp62_, (gint64) GLIBTOP_KERN_PROC_UID, (gint64) _data_->uid);
#line 138 "../src/utils/ProcessManager.vala"
	_data_->proclist = _data_->_tmp62_;
#line 138 "../src/utils/ProcessManager.vala"
	_data_->pids = _data_->_tmp63_;
#line 138 "../src/utils/ProcessManager.vala"
	_data_->pids_length1 = -1;
#line 138 "../src/utils/ProcessManager.vala"
	_data_->_pids_size_ = _data_->pids_length1;
#line 856 "ProcessManager.c"
	{
#line 140 "../src/utils/ProcessManager.vala"
		_data_->_vala2_i = 0;
#line 860 "ProcessManager.c"
		{
#line 140 "../src/utils/ProcessManager.vala"
			_data_->_tmp64_ = TRUE;
#line 140 "../src/utils/ProcessManager.vala"
			while (TRUE) {
#line 140 "../src/utils/ProcessManager.vala"
				if (!_data_->_tmp64_) {
#line 140 "../src/utils/ProcessManager.vala"
					_data_->_tmp65_ = _data_->_vala2_i;
#line 140 "../src/utils/ProcessManager.vala"
					_data_->_vala2_i = _data_->_tmp65_ + 1;
#line 872 "ProcessManager.c"
				}
#line 140 "../src/utils/ProcessManager.vala"
				_data_->_tmp64_ = FALSE;
#line 140 "../src/utils/ProcessManager.vala"
				_data_->_tmp66_ = _data_->proclist;
#line 140 "../src/utils/ProcessManager.vala"
				if (!(((guint64) _data_->_vala2_i) < _data_->_tmp66_.number)) {
#line 140 "../src/utils/ProcessManager.vala"
					break;
#line 882 "ProcessManager.c"
				}
#line 141 "../src/utils/ProcessManager.vala"
				_data_->_tmp67_ = _data_->pids;
#line 141 "../src/utils/ProcessManager.vala"
				_data_->_tmp67__length1 = _data_->pids_length1;
#line 141 "../src/utils/ProcessManager.vala"
				_data_->_tmp68_ = _data_->_tmp67_[_data_->_vala2_i];
#line 141 "../src/utils/ProcessManager.vala"
				_data_->_vala1_pid = _data_->_tmp68_;
#line 143 "../src/utils/ProcessManager.vala"
				_data_->_tmp70_ = _data_->self->priv->process_list;
#line 143 "../src/utils/ProcessManager.vala"
				if (!gee_abstract_map_has_key ((GeeAbstractMap*) _data_->_tmp70_, (gpointer) ((gintptr) _data_->_vala1_pid))) {
#line 143 "../src/utils/ProcessManager.vala"
					_data_->_tmp71_ = _data_->self->priv->kernel_process_blacklist;
#line 143 "../src/utils/ProcessManager.vala"
					_data_->_tmp69_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _data_->_tmp71_, (gpointer) ((gintptr) _data_->_vala1_pid));
#line 900 "ProcessManager.c"
				} else {
#line 143 "../src/utils/ProcessManager.vala"
					_data_->_tmp69_ = FALSE;
#line 904 "ProcessManager.c"
				}
#line 143 "../src/utils/ProcessManager.vala"
				if (_data_->_tmp69_) {
#line 144 "../src/utils/ProcessManager.vala"
					_data_->_tmp72_ = optimizer_utils_process_manager_add_process (_data_->self, _data_->_vala1_pid);
#line 144 "../src/utils/ProcessManager.vala"
					_data_->_tmp73_ = _data_->_tmp72_;
#line 144 "../src/utils/ProcessManager.vala"
					_optimizer_utils_process_unref0 (_data_->_tmp73_);
#line 914 "ProcessManager.c"
				}
			}
		}
	}
#line 148 "../src/utils/ProcessManager.vala"
	_data_->self->priv->cpu_last_used = _data_->used;
#line 149 "../src/utils/ProcessManager.vala"
	_data_->_tmp74_ = _data_->cpu_data;
#line 149 "../src/utils/ProcessManager.vala"
	_data_->self->priv->cpu_last_total = _data_->_tmp74_.total;
#line 150 "../src/utils/ProcessManager.vala"
	_data_->_tmp75_ = _data_->useds;
#line 150 "../src/utils/ProcessManager.vala"
	_data_->_tmp75__length1 = _data_->useds_length1;
#line 150 "../src/utils/ProcessManager.vala"
	_data_->_tmp76_ = (_data_->_tmp75_ != NULL) ? _vala_array_dup3 (_data_->_tmp75_, _data_->_tmp75__length1) : ((gpointer) _data_->_tmp75_);
#line 150 "../src/utils/ProcessManager.vala"
	_data_->_tmp76__length1 = _data_->_tmp75__length1;
#line 150 "../src/utils/ProcessManager.vala"
	_data_->self->priv->cpu_last_useds = (g_free (_data_->self->priv->cpu_last_useds), NULL);
#line 150 "../src/utils/ProcessManager.vala"
	_data_->self->priv->cpu_last_useds = _data_->_tmp76_;
#line 150 "../src/utils/ProcessManager.vala"
	_data_->self->priv->cpu_last_useds_length1 = _data_->_tmp76__length1;
#line 150 "../src/utils/ProcessManager.vala"
	_data_->self->priv->_cpu_last_useds_size_ = _data_->self->priv->cpu_last_useds_length1;
#line 151 "../src/utils/ProcessManager.vala"
	_data_->_tmp77_ = _data_->cpu_data;
#line 151 "../src/utils/ProcessManager.vala"
	_data_->_tmp78_ = _data_->_tmp77_.xcpu_total;
#line 151 "../src/utils/ProcessManager.vala"
	_data_->_tmp78__length1 = _vala_array_length (_data_->_tmp77_.xcpu_total);
#line 151 "../src/utils/ProcessManager.vala"
	_data_->_tmp79_ = (_data_->_tmp78_ != NULL) ? _vala_array_dup4 (_data_->_tmp78_, _data_->_tmp78__length1) : ((gpointer) _data_->_tmp78_);
#line 151 "../src/utils/ProcessManager.vala"
	_data_->_tmp79__length1 = _data_->_tmp78__length1;
#line 151 "../src/utils/ProcessManager.vala"
	_data_->self->priv->cpu_last_totals = (g_free (_data_->self->priv->cpu_last_totals), NULL);
#line 151 "../src/utils/ProcessManager.vala"
	_data_->self->priv->cpu_last_totals = _data_->_tmp79_;
#line 151 "../src/utils/ProcessManager.vala"
	_data_->self->priv->cpu_last_totals_length1 = _data_->_tmp79__length1;
#line 151 "../src/utils/ProcessManager.vala"
	_data_->self->priv->_cpu_last_totals_size_ = _data_->self->priv->cpu_last_totals_length1;
#line 154 "../src/utils/ProcessManager.vala"
	g_signal_emit (_data_->self, optimizer_utils_process_manager_signals[OPTIMIZER_UTILS_PROCESS_MANAGER_UPDATED_SIGNAL], 0);
#line 103 "../src/utils/ProcessManager.vala"
	_data_->pids = (g_free (_data_->pids), NULL);
#line 103 "../src/utils/ProcessManager.vala"
	_g_object_unref0 (_data_->remove_me);
#line 103 "../src/utils/ProcessManager.vala"
	_data_->useds = (g_free (_data_->useds), NULL);
#line 103 "../src/utils/ProcessManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 103 "../src/utils/ProcessManager.vala"
	if (_data_->_state_ != 0) {
#line 103 "../src/utils/ProcessManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 103 "../src/utils/ProcessManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 975 "ProcessManager.c"
		}
	}
#line 103 "../src/utils/ProcessManager.vala"
	g_object_unref (_data_->_async_result);
#line 103 "../src/utils/ProcessManager.vala"
	return FALSE;
#line 982 "ProcessManager.c"
}

/**
         * Parses a pid and adds a Process to our process_list or to the kernel_blacklist
         *
         * returns the created process
         */
static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 162 "../src/utils/ProcessManager.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 162 "../src/utils/ProcessManager.vala"
	return _data2_;
#line 997 "ProcessManager.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 162 "../src/utils/ProcessManager.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1007 "ProcessManager.c"
		OptimizerUtilsProcessManager* self;
#line 162 "../src/utils/ProcessManager.vala"
		self = _data2_->self;
#line 162 "../src/utils/ProcessManager.vala"
		_optimizer_utils_process_unref0 (_data2_->process);
#line 162 "../src/utils/ProcessManager.vala"
		_optimizer_utils_process_manager_unref0 (self);
#line 162 "../src/utils/ProcessManager.vala"
		g_slice_free (Block2Data, _data2_);
#line 1017 "ProcessManager.c"
	}
}

static gboolean
____lambda17_ (Block2Data* _data2_)
{
	OptimizerUtilsProcessManager* self;
	gboolean result = FALSE;
	OptimizerUtilsProcess* _tmp0_;
#line 171 "../src/utils/ProcessManager.vala"
	self = _data2_->self;
#line 171 "../src/utils/ProcessManager.vala"
	_tmp0_ = _data2_->process;
#line 171 "../src/utils/ProcessManager.vala"
	g_signal_emit (self, optimizer_utils_process_manager_signals[OPTIMIZER_UTILS_PROCESS_MANAGER_PROCESS_ADDED_SIGNAL], 0, _tmp0_);
#line 171 "../src/utils/ProcessManager.vala"
	result = FALSE;
#line 171 "../src/utils/ProcessManager.vala"
	return result;
#line 1037 "ProcessManager.c"
}

static gboolean
_____lambda17__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda17_ (self);
#line 171 "../src/utils/ProcessManager.vala"
	return result;
#line 1047 "ProcessManager.c"
}

static gpointer
_optimizer_utils_process_ref0 (gpointer self)
{
#line 173 "../src/utils/ProcessManager.vala"
	return self ? optimizer_utils_process_ref (self) : NULL;
#line 1055 "ProcessManager.c"
}

static OptimizerUtilsProcess*
optimizer_utils_process_manager_add_process (OptimizerUtilsProcessManager* self,
                                             gint pid)
{
	OptimizerUtilsProcess* result = NULL;
	Block2Data* _data2_;
	OptimizerUtilsProcess* _tmp0_;
	OptimizerUtilsProcess* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 162 "../src/utils/ProcessManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 162 "../src/utils/ProcessManager.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 162 "../src/utils/ProcessManager.vala"
	_data2_->_ref_count_ = 1;
#line 162 "../src/utils/ProcessManager.vala"
	_data2_->self = optimizer_utils_process_manager_ref (self);
#line 164 "../src/utils/ProcessManager.vala"
	_tmp0_ = optimizer_utils_process_new (pid);
#line 164 "../src/utils/ProcessManager.vala"
	_data2_->process = _tmp0_;
#line 166 "../src/utils/ProcessManager.vala"
	_tmp1_ = _data2_->process;
#line 166 "../src/utils/ProcessManager.vala"
	_tmp2_ = optimizer_utils_process_get_exists (_tmp1_);
#line 166 "../src/utils/ProcessManager.vala"
	_tmp3_ = _tmp2_;
#line 166 "../src/utils/ProcessManager.vala"
	if (_tmp3_) {
#line 1088 "ProcessManager.c"
		OptimizerUtilsProcess* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 167 "../src/utils/ProcessManager.vala"
		_tmp4_ = _data2_->process;
#line 167 "../src/utils/ProcessManager.vala"
		_tmp5_ = optimizer_utils_process_get_pgrp (_tmp4_);
#line 167 "../src/utils/ProcessManager.vala"
		_tmp6_ = _tmp5_;
#line 167 "../src/utils/ProcessManager.vala"
		if (_tmp6_ != 0) {
#line 1100 "ProcessManager.c"
			GeeHashMap* _tmp7_;
			OptimizerUtilsProcess* _tmp8_;
			OptimizerUtilsProcess* _tmp9_;
			OptimizerUtilsProcess* _tmp10_;
#line 169 "../src/utils/ProcessManager.vala"
			_tmp7_ = self->priv->process_list;
#line 169 "../src/utils/ProcessManager.vala"
			_tmp8_ = _data2_->process;
#line 169 "../src/utils/ProcessManager.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp7_, (gpointer) ((gintptr) pid), _tmp8_);
#line 171 "../src/utils/ProcessManager.vala"
			g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _____lambda17__gsource_func, block2_data_ref (_data2_), block2_data_unref);
#line 173 "../src/utils/ProcessManager.vala"
			_tmp9_ = _data2_->process;
#line 173 "../src/utils/ProcessManager.vala"
			_tmp10_ = _optimizer_utils_process_ref0 (_tmp9_);
#line 173 "../src/utils/ProcessManager.vala"
			result = _tmp10_;
#line 173 "../src/utils/ProcessManager.vala"
			block2_data_unref (_data2_);
#line 173 "../src/utils/ProcessManager.vala"
			_data2_ = NULL;
#line 173 "../src/utils/ProcessManager.vala"
			return result;
#line 1125 "ProcessManager.c"
		} else {
			GeeHashSet* _tmp11_;
#line 176 "../src/utils/ProcessManager.vala"
			_tmp11_ = self->priv->kernel_process_blacklist;
#line 176 "../src/utils/ProcessManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, (gpointer) ((gintptr) pid));
#line 1132 "ProcessManager.c"
		}
	}
#line 180 "../src/utils/ProcessManager.vala"
	result = NULL;
#line 180 "../src/utils/ProcessManager.vala"
	block2_data_unref (_data2_);
#line 180 "../src/utils/ProcessManager.vala"
	_data2_ = NULL;
#line 180 "../src/utils/ProcessManager.vala"
	return result;
#line 1143 "ProcessManager.c"
}

/**
         * Remove the process from all lists and broadcast the process_removed signal if removed.
         */
static void
optimizer_utils_process_manager_remove_process (OptimizerUtilsProcessManager* self,
                                                gint pid)
{
	GeeHashMap* _tmp0_;
#line 187 "../src/utils/ProcessManager.vala"
	g_return_if_fail (self != NULL);
#line 188 "../src/utils/ProcessManager.vala"
	_tmp0_ = self->priv->process_list;
#line 188 "../src/utils/ProcessManager.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) pid))) {
#line 1160 "ProcessManager.c"
		GeeHashMap* _tmp1_;
#line 189 "../src/utils/ProcessManager.vala"
		_tmp1_ = self->priv->process_list;
#line 189 "../src/utils/ProcessManager.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp1_, (gpointer) ((gintptr) pid), NULL);
#line 190 "../src/utils/ProcessManager.vala"
		g_signal_emit (self, optimizer_utils_process_manager_signals[OPTIMIZER_UTILS_PROCESS_MANAGER_PROCESS_REMOVED_SIGNAL], 0, pid);
#line 1168 "ProcessManager.c"
	} else {
		GeeHashSet* _tmp2_;
#line 192 "../src/utils/ProcessManager.vala"
		_tmp2_ = self->priv->kernel_process_blacklist;
#line 192 "../src/utils/ProcessManager.vala"
		if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp2_, (gpointer) ((gintptr) pid))) {
#line 1175 "ProcessManager.c"
			GeeHashSet* _tmp3_;
#line 193 "../src/utils/ProcessManager.vala"
			_tmp3_ = self->priv->kernel_process_blacklist;
#line 193 "../src/utils/ProcessManager.vala"
			gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp3_, (gpointer) ((gintptr) pid));
#line 1181 "ProcessManager.c"
		}
	}
}

/**
         * Returns a single instance of this class.
         *
         * @return {@code ProcessManager}
         */
OptimizerUtilsProcessManager*
optimizer_utils_process_manager_get_instance (void)
{
	OptimizerUtilsProcessManager* result = NULL;
	OptimizerUtilsProcessManager* _tmp0_;
	OptimizerUtilsProcessManager* _tmp2_;
#line 203 "../src/utils/ProcessManager.vala"
	_tmp0_ = optimizer_utils_process_manager_instance;
#line 203 "../src/utils/ProcessManager.vala"
	if (_tmp0_ == NULL) {
#line 1201 "ProcessManager.c"
		OptimizerUtilsProcessManager* _tmp1_;
#line 204 "../src/utils/ProcessManager.vala"
		_tmp1_ = optimizer_utils_process_manager_new ();
#line 204 "../src/utils/ProcessManager.vala"
		_optimizer_utils_process_manager_unref0 (optimizer_utils_process_manager_instance);
#line 204 "../src/utils/ProcessManager.vala"
		optimizer_utils_process_manager_instance = _tmp1_;
#line 1209 "ProcessManager.c"
	}
#line 207 "../src/utils/ProcessManager.vala"
	_tmp2_ = optimizer_utils_process_manager_instance;
#line 207 "../src/utils/ProcessManager.vala"
	result = _tmp2_;
#line 207 "../src/utils/ProcessManager.vala"
	return result;
#line 1217 "ProcessManager.c"
}

gdouble
optimizer_utils_process_manager_get_cpu_load (OptimizerUtilsProcessManager* self)
{
	gdouble result;
#line 37 "../src/utils/ProcessManager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 37 "../src/utils/ProcessManager.vala"
	result = self->priv->_cpu_load;
#line 37 "../src/utils/ProcessManager.vala"
	return result;
#line 1230 "ProcessManager.c"
}

static void
optimizer_utils_process_manager_set_cpu_load (OptimizerUtilsProcessManager* self,
                                              gdouble value)
{
#line 37 "../src/utils/ProcessManager.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/utils/ProcessManager.vala"
	self->priv->_cpu_load = value;
#line 1241 "ProcessManager.c"
}

gdouble*
optimizer_utils_process_manager_get_cpu_loads (OptimizerUtilsProcessManager* self,
                                               gint* result_length1)
{
	gdouble* result;
	gdouble* _tmp0_;
	gint _tmp0__length1;
	gdouble* _tmp1_;
	gint _tmp1__length1;
#line 38 "../src/utils/ProcessManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/utils/ProcessManager.vala"
	_tmp0_ = self->priv->_cpu_loads;
#line 38 "../src/utils/ProcessManager.vala"
	_tmp0__length1 = self->priv->_cpu_loads_length1;
#line 38 "../src/utils/ProcessManager.vala"
	_tmp1_ = _tmp0_;
#line 38 "../src/utils/ProcessManager.vala"
	_tmp1__length1 = _tmp0__length1;
#line 38 "../src/utils/ProcessManager.vala"
	if (result_length1) {
#line 38 "../src/utils/ProcessManager.vala"
		*result_length1 = _tmp1__length1;
#line 1267 "ProcessManager.c"
	}
#line 38 "../src/utils/ProcessManager.vala"
	result = _tmp1_;
#line 38 "../src/utils/ProcessManager.vala"
	return result;
#line 1273 "ProcessManager.c"
}

static gdouble*
_vala_array_dup5 (gdouble* self,
                  int length)
{
#line 38 "../src/utils/ProcessManager.vala"
	return g_memdup (self, length * sizeof (gdouble));
#line 1282 "ProcessManager.c"
}

static void
optimizer_utils_process_manager_set_cpu_loads (OptimizerUtilsProcessManager* self,
                                               gdouble* value,
                                               gint value_length1)
{
	gdouble* _tmp0_;
	gint _tmp0__length1;
#line 38 "../src/utils/ProcessManager.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/utils/ProcessManager.vala"
	_tmp0_ = (value != NULL) ? _vala_array_dup5 (value, value_length1) : ((gpointer) value);
#line 38 "../src/utils/ProcessManager.vala"
	_tmp0__length1 = value_length1;
#line 38 "../src/utils/ProcessManager.vala"
	self->priv->_cpu_loads = (g_free (self->priv->_cpu_loads), NULL);
#line 38 "../src/utils/ProcessManager.vala"
	self->priv->_cpu_loads = _tmp0_;
#line 38 "../src/utils/ProcessManager.vala"
	self->priv->_cpu_loads_length1 = _tmp0__length1;
#line 38 "../src/utils/ProcessManager.vala"
	self->priv->__cpu_loads_size_ = self->priv->_cpu_loads_length1;
#line 1306 "ProcessManager.c"
}

static void
g_cclosure_user_marshal_VOID__OPTIMIZER_UTILS_PROCESS (GClosure * closure,
                                                       GValue * return_value,
                                                       guint n_param_values,
                                                       const GValue * param_values,
                                                       gpointer invocation_hint,
                                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OPTIMIZER_UTILS_PROCESS) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__OPTIMIZER_UTILS_PROCESS callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 31 "../src/utils/ProcessManager.vala"
	g_return_if_fail (n_param_values == 2);
#line 31 "../src/utils/ProcessManager.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 31 "../src/utils/ProcessManager.vala"
		data1 = closure->data;
#line 31 "../src/utils/ProcessManager.vala"
		data2 = param_values->data[0].v_pointer;
#line 1331 "ProcessManager.c"
	} else {
#line 31 "../src/utils/ProcessManager.vala"
		data1 = param_values->data[0].v_pointer;
#line 31 "../src/utils/ProcessManager.vala"
		data2 = closure->data;
#line 1337 "ProcessManager.c"
	}
#line 31 "../src/utils/ProcessManager.vala"
	callback = (GMarshalFunc_VOID__OPTIMIZER_UTILS_PROCESS) (marshal_data ? marshal_data : cc->callback);
#line 31 "../src/utils/ProcessManager.vala"
	callback (data1, optimizer_utils_value_get_process (param_values + 1), data2);
#line 1343 "ProcessManager.c"
}

static void
optimizer_utils_value_process_manager_init (GValue* value)
{
#line 31 "../src/utils/ProcessManager.vala"
	value->data[0].v_pointer = NULL;
#line 1351 "ProcessManager.c"
}

static void
optimizer_utils_value_process_manager_free_value (GValue* value)
{
#line 31 "../src/utils/ProcessManager.vala"
	if (value->data[0].v_pointer) {
#line 31 "../src/utils/ProcessManager.vala"
		optimizer_utils_process_manager_unref (value->data[0].v_pointer);
#line 1361 "ProcessManager.c"
	}
}

static void
optimizer_utils_value_process_manager_copy_value (const GValue* src_value,
                                                  GValue* dest_value)
{
#line 31 "../src/utils/ProcessManager.vala"
	if (src_value->data[0].v_pointer) {
#line 31 "../src/utils/ProcessManager.vala"
		dest_value->data[0].v_pointer = optimizer_utils_process_manager_ref (src_value->data[0].v_pointer);
#line 1373 "ProcessManager.c"
	} else {
#line 31 "../src/utils/ProcessManager.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1377 "ProcessManager.c"
	}
}

static gpointer
optimizer_utils_value_process_manager_peek_pointer (const GValue* value)
{
#line 31 "../src/utils/ProcessManager.vala"
	return value->data[0].v_pointer;
#line 1386 "ProcessManager.c"
}

static gchar*
optimizer_utils_value_process_manager_collect_value (GValue* value,
                                                     guint n_collect_values,
                                                     GTypeCValue* collect_values,
                                                     guint collect_flags)
{
#line 31 "../src/utils/ProcessManager.vala"
	if (collect_values[0].v_pointer) {
#line 1397 "ProcessManager.c"
		OptimizerUtilsProcessManager * object;
		object = collect_values[0].v_pointer;
#line 31 "../src/utils/ProcessManager.vala"
		if (object->parent_instance.g_class == NULL) {
#line 31 "../src/utils/ProcessManager.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1404 "ProcessManager.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 31 "../src/utils/ProcessManager.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1408 "ProcessManager.c"
		}
#line 31 "../src/utils/ProcessManager.vala"
		value->data[0].v_pointer = optimizer_utils_process_manager_ref (object);
#line 1412 "ProcessManager.c"
	} else {
#line 31 "../src/utils/ProcessManager.vala"
		value->data[0].v_pointer = NULL;
#line 1416 "ProcessManager.c"
	}
#line 31 "../src/utils/ProcessManager.vala"
	return NULL;
#line 1420 "ProcessManager.c"
}

static gchar*
optimizer_utils_value_process_manager_lcopy_value (const GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
	OptimizerUtilsProcessManager ** object_p;
	object_p = collect_values[0].v_pointer;
#line 31 "../src/utils/ProcessManager.vala"
	if (!object_p) {
#line 31 "../src/utils/ProcessManager.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1435 "ProcessManager.c"
	}
#line 31 "../src/utils/ProcessManager.vala"
	if (!value->data[0].v_pointer) {
#line 31 "../src/utils/ProcessManager.vala"
		*object_p = NULL;
#line 1441 "ProcessManager.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 31 "../src/utils/ProcessManager.vala"
		*object_p = value->data[0].v_pointer;
#line 1445 "ProcessManager.c"
	} else {
#line 31 "../src/utils/ProcessManager.vala"
		*object_p = optimizer_utils_process_manager_ref (value->data[0].v_pointer);
#line 1449 "ProcessManager.c"
	}
#line 31 "../src/utils/ProcessManager.vala"
	return NULL;
#line 1453 "ProcessManager.c"
}

GParamSpec*
optimizer_utils_param_spec_process_manager (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags)
{
	OptimizerUtilsParamSpecProcessManager* spec;
#line 31 "../src/utils/ProcessManager.vala"
	g_return_val_if_fail (g_type_is_a (object_type, OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER), NULL);
#line 31 "../src/utils/ProcessManager.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 31 "../src/utils/ProcessManager.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 31 "../src/utils/ProcessManager.vala"
	return G_PARAM_SPEC (spec);
#line 1472 "ProcessManager.c"
}

gpointer
optimizer_utils_value_get_process_manager (const GValue* value)
{
#line 31 "../src/utils/ProcessManager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER), NULL);
#line 31 "../src/utils/ProcessManager.vala"
	return value->data[0].v_pointer;
#line 1482 "ProcessManager.c"
}

void
optimizer_utils_value_set_process_manager (GValue* value,
                                           gpointer v_object)
{
	OptimizerUtilsProcessManager * old;
#line 31 "../src/utils/ProcessManager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER));
#line 31 "../src/utils/ProcessManager.vala"
	old = value->data[0].v_pointer;
#line 31 "../src/utils/ProcessManager.vala"
	if (v_object) {
#line 31 "../src/utils/ProcessManager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER));
#line 31 "../src/utils/ProcessManager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 31 "../src/utils/ProcessManager.vala"
		value->data[0].v_pointer = v_object;
#line 31 "../src/utils/ProcessManager.vala"
		optimizer_utils_process_manager_ref (value->data[0].v_pointer);
#line 1504 "ProcessManager.c"
	} else {
#line 31 "../src/utils/ProcessManager.vala"
		value->data[0].v_pointer = NULL;
#line 1508 "ProcessManager.c"
	}
#line 31 "../src/utils/ProcessManager.vala"
	if (old) {
#line 31 "../src/utils/ProcessManager.vala"
		optimizer_utils_process_manager_unref (old);
#line 1514 "ProcessManager.c"
	}
}

void
optimizer_utils_value_take_process_manager (GValue* value,
                                            gpointer v_object)
{
	OptimizerUtilsProcessManager * old;
#line 31 "../src/utils/ProcessManager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER));
#line 31 "../src/utils/ProcessManager.vala"
	old = value->data[0].v_pointer;
#line 31 "../src/utils/ProcessManager.vala"
	if (v_object) {
#line 31 "../src/utils/ProcessManager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER));
#line 31 "../src/utils/ProcessManager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 31 "../src/utils/ProcessManager.vala"
		value->data[0].v_pointer = v_object;
#line 1535 "ProcessManager.c"
	} else {
#line 31 "../src/utils/ProcessManager.vala"
		value->data[0].v_pointer = NULL;
#line 1539 "ProcessManager.c"
	}
#line 31 "../src/utils/ProcessManager.vala"
	if (old) {
#line 31 "../src/utils/ProcessManager.vala"
		optimizer_utils_process_manager_unref (old);
#line 1545 "ProcessManager.c"
	}
}

static void
optimizer_utils_process_manager_class_init (OptimizerUtilsProcessManagerClass * klass,
                                            gpointer klass_data)
{
#line 31 "../src/utils/ProcessManager.vala"
	optimizer_utils_process_manager_parent_class = g_type_class_peek_parent (klass);
#line 31 "../src/utils/ProcessManager.vala"
	((OptimizerUtilsProcessManagerClass *) klass)->finalize = optimizer_utils_process_manager_finalize;
#line 31 "../src/utils/ProcessManager.vala"
	g_type_class_adjust_private_offset (klass, &OptimizerUtilsProcessManager_private_offset);
#line 31 "../src/utils/ProcessManager.vala"
	optimizer_utils_process_manager_signals[OPTIMIZER_UTILS_PROCESS_MANAGER_PROCESS_ADDED_SIGNAL] = g_signal_new ("process-added", OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OPTIMIZER_UTILS_PROCESS, G_TYPE_NONE, 1, OPTIMIZER_UTILS_TYPE_PROCESS);
#line 31 "../src/utils/ProcessManager.vala"
	optimizer_utils_process_manager_signals[OPTIMIZER_UTILS_PROCESS_MANAGER_PROCESS_REMOVED_SIGNAL] = g_signal_new ("process-removed", OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 31 "../src/utils/ProcessManager.vala"
	optimizer_utils_process_manager_signals[OPTIMIZER_UTILS_PROCESS_MANAGER_UPDATED_SIGNAL] = g_signal_new ("updated", OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1565 "ProcessManager.c"
}

static void
optimizer_utils_process_manager_instance_init (OptimizerUtilsProcessManager * self,
                                               gpointer klass)
{
	guint64* _tmp0_;
	guint64* _tmp1_;
#line 31 "../src/utils/ProcessManager.vala"
	self->priv = optimizer_utils_process_manager_get_instance_private (self);
#line 40 "../src/utils/ProcessManager.vala"
	self->priv->cpu_last_used = (guint64) 0;
#line 41 "../src/utils/ProcessManager.vala"
	self->priv->cpu_last_total = (guint64) 0;
#line 42 "../src/utils/ProcessManager.vala"
	_tmp0_ = g_new0 (guint64, 32);
#line 42 "../src/utils/ProcessManager.vala"
	self->priv->cpu_last_useds = _tmp0_;
#line 42 "../src/utils/ProcessManager.vala"
	self->priv->cpu_last_useds_length1 = 32;
#line 42 "../src/utils/ProcessManager.vala"
	self->priv->_cpu_last_useds_size_ = self->priv->cpu_last_useds_length1;
#line 43 "../src/utils/ProcessManager.vala"
	_tmp1_ = g_new0 (guint64, 32);
#line 43 "../src/utils/ProcessManager.vala"
	self->priv->cpu_last_totals = _tmp1_;
#line 43 "../src/utils/ProcessManager.vala"
	self->priv->cpu_last_totals_length1 = 32;
#line 43 "../src/utils/ProcessManager.vala"
	self->priv->_cpu_last_totals_size_ = self->priv->cpu_last_totals_length1;
#line 31 "../src/utils/ProcessManager.vala"
	self->ref_count = 1;
#line 1598 "ProcessManager.c"
}

static void
optimizer_utils_process_manager_finalize (OptimizerUtilsProcessManager * obj)
{
	OptimizerUtilsProcessManager * self;
#line 31 "../src/utils/ProcessManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER, OptimizerUtilsProcessManager);
#line 31 "../src/utils/ProcessManager.vala"
	g_signal_handlers_destroy (self);
#line 38 "../src/utils/ProcessManager.vala"
	self->priv->_cpu_loads = (g_free (self->priv->_cpu_loads), NULL);
#line 42 "../src/utils/ProcessManager.vala"
	self->priv->cpu_last_useds = (g_free (self->priv->cpu_last_useds), NULL);
#line 43 "../src/utils/ProcessManager.vala"
	self->priv->cpu_last_totals = (g_free (self->priv->cpu_last_totals), NULL);
#line 45 "../src/utils/ProcessManager.vala"
	_g_object_unref0 (self->priv->process_list);
#line 46 "../src/utils/ProcessManager.vala"
	_g_object_unref0 (self->priv->kernel_process_blacklist);
#line 1619 "ProcessManager.c"
}

/**
     * The {@code ProcessManager} class is responsible for getting information about
     * running processes
     *
     * @since 1.0.0
     */
GType
optimizer_utils_process_manager_get_type (void)
{
	static volatile gsize optimizer_utils_process_manager_type_id__volatile = 0;
	if (g_once_init_enter (&optimizer_utils_process_manager_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { optimizer_utils_value_process_manager_init, optimizer_utils_value_process_manager_free_value, optimizer_utils_value_process_manager_copy_value, optimizer_utils_value_process_manager_peek_pointer, "p", optimizer_utils_value_process_manager_collect_value, "p", optimizer_utils_value_process_manager_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (OptimizerUtilsProcessManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) optimizer_utils_process_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (OptimizerUtilsProcessManager), 0, (GInstanceInitFunc) optimizer_utils_process_manager_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType optimizer_utils_process_manager_type_id;
		optimizer_utils_process_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "OptimizerUtilsProcessManager", &g_define_type_info, &g_define_type_fundamental_info, 0);
		OptimizerUtilsProcessManager_private_offset = g_type_add_instance_private (optimizer_utils_process_manager_type_id, sizeof (OptimizerUtilsProcessManagerPrivate));
		g_once_init_leave (&optimizer_utils_process_manager_type_id__volatile, optimizer_utils_process_manager_type_id);
	}
	return optimizer_utils_process_manager_type_id__volatile;
}

gpointer
optimizer_utils_process_manager_ref (gpointer instance)
{
	OptimizerUtilsProcessManager * self;
	self = instance;
#line 31 "../src/utils/ProcessManager.vala"
	g_atomic_int_inc (&self->ref_count);
#line 31 "../src/utils/ProcessManager.vala"
	return instance;
#line 1653 "ProcessManager.c"
}

void
optimizer_utils_process_manager_unref (gpointer instance)
{
	OptimizerUtilsProcessManager * self;
	self = instance;
#line 31 "../src/utils/ProcessManager.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 31 "../src/utils/ProcessManager.vala"
		OPTIMIZER_UTILS_PROCESS_MANAGER_GET_CLASS (self)->finalize (self);
#line 31 "../src/utils/ProcessManager.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1667 "ProcessManager.c"
	}
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

